package dev.peerat.parser.java.builder;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Parser;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.JavaParser;
import dev.peerat.parser.java.tree.JavaTreeType;
import dev.peerat.parser.java.value.Value;
import dev.peerat.parser.java.value.Value.ValueContainer;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.VisitorBag;

public class JavaValueBuilder extends JavaBuilder<Value>{

	private static Parser<JavaElement> PARSER = new JavaParser(JavaTreeType.VALUE);
	
	private Value value;
	
	public JavaValueBuilder(String value) throws Exception{
		PARSER.parse(value, new Container());
	}

	@Override
	public Value build(){
		return this.value;
	}

	class Container extends JavaElement implements ValueContainer{

		@Override
		public void addValue(Value value) {
			JavaValueBuilder.this.value = value;
		}
		
		@Override
		public void build(Builder builder) throws Exception {
			
		}

		@Override
		public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
			return null;
		}

		@Override
		public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
			
		}

		@Override
		public VisitorBag visit(JavaVisitor<?> visitor) {
			return null;
		}
		
	}
}
